//
//  AppDelegate.swift
//  VoltageRatio
//
//  Created by Phidgets on 2018-02-21.
//  Copyright © 2018 Phidgets. All rights reserved.
//

import Cocoa
import Phidget22Swift

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {

    @IBOutlet weak var window: NSWindow!
    let ch = VoltageRatioInput()
    @IBOutlet weak var phidgetInfoBox: PhidgetInfoBox!
    
    //GUI
    @IBOutlet weak var changeTriggerSlider: NSSlider!
    @IBOutlet weak var minChangeTriggerLabel: NSTextField!
    @IBOutlet weak var maxChangeTriggerLabel: NSTextField!
    @IBOutlet weak var changeTriggerLabel: NSTextField!
    @IBOutlet weak var dataIntervalSlider: NSSlider!
    @IBOutlet weak var minDataIntervalLabel: NSTextField!
    @IBOutlet weak var maxDataIntervalLabel: NSTextField!
    @IBOutlet weak var dataIntervalLabel: NSTextField!
    @IBOutlet weak var voltageRatioLabel: NSTextField!
    @IBOutlet weak var dataBox: NSBox!
    @IBOutlet weak var sensorTypeBox: NSBox!
    @IBOutlet weak var sensorValueLabel: NSTextField!
    @IBOutlet weak var dataIntervalBox: NSBox!
    @IBOutlet weak var changeTriggerBox: NSBox!
    @IBOutlet weak var bridgeGainBox: NSBox!
    @IBOutlet weak var enableCheck: NSButton!
    @IBOutlet weak var enableBox: NSBox!
    @IBOutlet weak var sensorTypePopup: NSPopUpButton!
    @IBOutlet weak var bridgeGainPopup: NSPopUpButton!
    
    //Error Window
    @IBOutlet weak var errorEventWindow: NSPanel!
    @IBOutlet var errorEventLog: NSTextView!
    @IBOutlet weak var errorEventCount: NSTextField!
    var errorCounter = 0
    
var sensors: [String: VoltageRatioSensorType] =         [
                                                        "Generic ratiometric sensor"                                                    :VoltageRatioSensorType.voltageRatio,
                                                        "1101 - IR Distance Adapter, with Sharp Distance Sensor 2D120X (4-30cm)"        :VoltageRatioSensorType.PN_1101_Sharp2D120X,
                                                        "1101 - IR Distance Adapter, with Sharp Distance Sensor 2Y0A21 (10-80cm)"       :VoltageRatioSensorType.PN_1101_Sharp2Y0A21,
                                                        "1101 - IR Distance Adapter, with Sharp Distance Sensor 2Y0A02 (20-150cm)"      :VoltageRatioSensorType.PN_1101_Sharp2Y0A02,
                                                        "1102 - IR Reflective Sensor 5mm"                                               :VoltageRatioSensorType.PN_1102,
                                                        "1103 - IR Reflective Sensor 10cm"                                              :VoltageRatioSensorType.PN_1103,
                                                        "1104 - Vibchn Sensor"                                                          :VoltageRatioSensorType.PN_1104,
                                                        "1105 - Light Sensor"                                                           :VoltageRatioSensorType.PN_1105,
                                                        "1106 - Force Sensor"                                                           :VoltageRatioSensorType.PN_1106,
                                                        "1107 - Humidity Sensor"                                                        :VoltageRatioSensorType.PN_1107,
                                                        "1108 - Magnetic Sensor"                                                        :VoltageRatioSensorType.PN_1108,
                                                        "1109 - Rotation Sensor"                                                        :VoltageRatioSensorType.PN_1109,
                                                        "1110 - Touch Sensor"                                                           :VoltageRatioSensorType.PN_1110,
                                                        "1111 - Motion Sensor"                                                          :VoltageRatioSensorType.PN_1111,
                                                        "1112 - Slider 60"                                                              :VoltageRatioSensorType.PN_1112,
                                                        "1113 - Mini Joy Stick Sensor"                                                  :VoltageRatioSensorType.PN_1113,
                                                        "1115 - Pressure Sensor"                                                        :VoltageRatioSensorType.PN_1115,
                                                        "1116 - Multi-turn Rotation Sensor"                                             :VoltageRatioSensorType.PN_1116,
                                                        "1118 - 50Amp Current Sensor AC"                                                :VoltageRatioSensorType.PN_1118_AC,
                                                        "1118 - 50Amp Current Sensor DC"                                                :VoltageRatioSensorType.PN_1118_DC,
                                                        "1119 - 20Amp Current Sensor AC"                                                :VoltageRatioSensorType.PN_1119_AC,
                                                        "1119 - 20Amp Current Sensor DC"                                                :VoltageRatioSensorType.PN_1119_DC,
                                                        "1120 - FlexiForce Adapter"                                                     :VoltageRatioSensorType.PN_1120,
                                                        "1121 - Voltage Divider"                                                        :VoltageRatioSensorType.PN_1121,
                                                        "1122 - 30 Amp Current Sensor AC"                                               :VoltageRatioSensorType.PN_1122_AC,
                                                        "1122 - 30 Amp Current Sensor DC"                                               :VoltageRatioSensorType.PN_1122_DC,
                                                        "1124 - Precision Temperature Sensor"                                           :VoltageRatioSensorType.PN_1124,
                                                        "1125 - Humidity Sensor"                                                        :VoltageRatioSensorType.PN_1125_Humidity,
                                                        "1125 - Temperature Sensor"                                                     :VoltageRatioSensorType.PN_1125_Temperature,
                                                        "1126 - Differential Air Pressure Sensor +- 25kPa"                              :VoltageRatioSensorType.PN_1126,
                                                        "1128 - MaxBotix EZ-1 Sonar Sensor"                                             :VoltageRatioSensorType.PN_1128,
                                                        "1129 - Touch Sensor"                                                           :VoltageRatioSensorType.PN_1129,
                                                        "1131 - Thin Force Sensor"                                                      :VoltageRatioSensorType.PN_1131,
                                                        "1134 - Switchable Voltage Divider"                                             :VoltageRatioSensorType.PN_1134,
                                                        "1136 - Differential Air Pressure Sensor +-2 kPa"                               :VoltageRatioSensorType.PN_1136,
                                                        "1137 - Differential Air Pressure Sensor +-7 kPa"                               :VoltageRatioSensorType.PN_1137,
                                                        "1138 - Differential Air Pressure Sensor 50 kPa"                                :VoltageRatioSensorType.PN_1138,
                                                        "1139 - Differential Air Pressure Sensor 100 kPa"                               :VoltageRatioSensorType.PN_1139,
                                                        "1140 - Absolute Air Pressure Sensor 20-400 kPa"                                :VoltageRatioSensorType.PN_1140,
                                                        "1141 - Absolute Air Pressure Sensor 15-115 kPa"                                :VoltageRatioSensorType.PN_1141,
                                                        "1146 - IR Reflective Sensor 1-4mm"                                             :VoltageRatioSensorType.PN_1146,
                                                        "3120 - Compression Load Cell (0-4.5 kg)"                                       :VoltageRatioSensorType.PN_3120,
                                                        "3121 - Compression Load Cell (0-11.3 kg)"                                      :VoltageRatioSensorType.PN_3121,
                                                        "3122 - Compression Load Cell (0-22.7 kg)"                                      :VoltageRatioSensorType.PN_3122,
                                                        "3123 - Compression Load Cell (0-45.3 kg)"                                      :VoltageRatioSensorType.PN_3123,
                                                        "3130 - Relative Humidity Sensor"                                               :VoltageRatioSensorType.PN_3130,
                                                        "3520 - Sharp Distance Sensor (4-30cm)"                                         :VoltageRatioSensorType.PN_3520,
                                                        "3521 - Sharp Distance Sensor (10-80cm)"                                        :VoltageRatioSensorType.PN_3521,
                                                        "3522 - Sharp Distance Sensor (20-150cm)"                                       :VoltageRatioSensorType.PN_3522]

    //MARK: View events
    func applicationDidFinishLaunching(_ aNotification: Notification) {
        do {
            //Adjusting window height
            var frame = self.window.frame
            frame.size.height = self.window.minSize.height
            self.window.setFrame(frame, display: true, animate: false)
            self.window.center()
            
            let sortedKeys = Array(sensors.keys).sorted(by: <)
            sensorTypePopup.addItem(withTitle: "Generic ratiometric sensor")
            for key in sortedKeys{
                if(key != "Generic ratiometric sensor"){
                    sensorTypePopup.addItem(withTitle: key)
                }
            }
            
            let _ = ch.attach.addHandler(attach_handler)
            let _ = ch.detach.addHandler(detach_handler)
            let _ = ch.error.addHandler(error_handler)
            let _ = ch.voltageRatioChange.addHandler(ratiochange_handler)
            let _ = ch.sensorChange.addHandler(sensorchange_handler)
            
            /*
             * Please review the Phidget22 channel matching documentation for details on the device
             * and class architecture of Phidget22, and how channels are matched to device features.
             */
            
            /*
             * Specifies the serial number of the device to attach to.
             * For VINT devices, this is the hub serial number.
             *
             * The default is any device.
             */
            // try ch.setDeviceSerialNumber(<YOUR DEVICE SERIAL NUMBER>)
            
            /*
             * For VINT devices, this specifies the port the VINT device must be plugged into.
             *
             * The default is any port.
             */
            // try ch.setHubPort(0)
            
            /*
             * Specifies which channel to attach to.  It is important that the channel of
             * the device is the same class as the channel that is being opened.
             *
             * The default is any channel.
             */
            // try ch.setChannel(0)
            
            /*
             * In order to attach to a network Phidget, the program must connect to a Phidget22 Network Server.
             * In a normal environment this can be done automatically by enabling server discovery, which
             * will cause the client to discovery and connect to available servers.
             *
             * To force the channel to only match a network Phidget, set remote to 1.
             */
            
            // try Net.enableServerDiscovery(serverType: .deviceRemote)
            // try ch.setIsRemote(true)
            
            /*
             openCmdLine allows command line arguments to be passed to this program in order to
             configure channel matching.
             If you have modified the code and added your own channel matching, comment out
             the openCmdLine call, and simply replace it with the following line:
             */
            //try ch.open()
            
            
            try phidgetInfoBox.openCmdLine(phid: ch as Phidget)
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    
    func applicationShouldTerminateAfterLastWindowClosed(_ sender: NSApplication) -> Bool {
        return true
    }
    
    func applicationWillTerminate(_ aNotification: Notification) {
        //Safely close example
        do{
            print("Closing")
            ch.attach.removeAllHandlers()
            ch.detach.removeAllHandlers()
            ch.error.removeAllHandlers()
            ch.voltageRatioChange.removeAllHandlers()
            ch.sensorChange.removeAllHandlers()
            try ch.close()
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    
    //MARK: Event handlers
    func attach_handler(sender: Phidget){
        do{
            let attachedDevice = sender as! VoltageRatioInput
            let subclass = try attachedDevice.getChannelSubclass()
            let deviceID = try attachedDevice.getDeviceID()
            let minChangeTrigger = try attachedDevice.getMinVoltageRatioChangeTrigger()
            let maxChangeTrigger = try attachedDevice.getMaxVoltageRatioChangeTrigger()
            let changeTrigger = try attachedDevice.getVoltageRatioChangeTrigger()
            let minDataInterval = try attachedDevice.getMinDataInterval()
            let maxDataInterval = try attachedDevice.getMaxDataInterval()
            let dataInterval = try attachedDevice.getDataInterval()
            let changeTriggerHidden = (maxChangeTrigger == minChangeTrigger) ? true : false
            var sensorBoxHidden = true
            let dataIntBoxHidden = false
            var bridgeHidden = true
            var bridgeGain:BridgeGain?
            var bridgeEnabled:Bool?
            
            if(subclass == ChannelSubclass.voltageRatioInputBridge){
                bridgeGain = try attachedDevice.getBridgeGain()
                bridgeEnabled = try attachedDevice.getBridgeEnabled()
                bridgeHidden = false
            }
            else if(subclass == ChannelSubclass.voltageRatioInputSensorPort){
                sensorBoxHidden = false
            }
            
            DispatchQueue.main.async {
                self.phidgetInfoBox.fillPhidgetInfo(device: sender)
                
                self.minChangeTriggerLabel.stringValue = String(format:"%.3f", minChangeTrigger)
                self.maxChangeTriggerLabel.stringValue = String(format:"%.3f", maxChangeTrigger)
                self.changeTriggerLabel.stringValue = String(format:"%.4f V", changeTrigger)
                self.changeTriggerSlider.doubleValue = changeTrigger
                
                self.changeTriggerSlider.minValue = minChangeTrigger
                self.changeTriggerSlider.maxValue = maxChangeTrigger
                self.changeTriggerSlider.doubleValue = changeTrigger
                
                self.minDataIntervalLabel.stringValue = String(format:"%d",minDataInterval)
                self.maxDataIntervalLabel.stringValue = String(format:"%d",maxDataInterval)
                self.dataIntervalLabel.stringValue = String(format:"%d ms",dataInterval)
                
                self.dataIntervalSlider.minValue = Double(minDataInterval)
                self.dataIntervalSlider.maxValue = Double(maxDataInterval)
                self.dataIntervalSlider.doubleValue = Double(dataInterval)
                
                
                if(subclass == ChannelSubclass.voltageRatioInputBridge){
                    self.bridgeGainPopup.addItem(withTitle: "1x")
                    if(deviceID != DeviceID.PN_1046){
                        self.bridgeGainPopup.addItem(withTitle: "2x")
                        self.bridgeGainPopup.addItem(withTitle: "4x")
                    }
                    self.bridgeGainPopup.addItem(withTitle: "8x")
                    self.bridgeGainPopup.addItem(withTitle: "16x")
                    self.bridgeGainPopup.addItem(withTitle: "32x")
                    self.bridgeGainPopup.addItem(withTitle: "64x")
                    self.bridgeGainPopup.addItem(withTitle: "128x")
                    self.bridgeGainPopup.selectItem(at: Int(bridgeGain!.rawValue) - 1)
                    self.enableCheck.state = bridgeEnabled! ? NSControl.StateValue.on : NSControl.StateValue.off
                }
                
                self.updateGUI(isDataIntHidden: dataIntBoxHidden, isTriggerHidden: changeTriggerHidden, isBridgeHidden: bridgeHidden, isSensorBoxHidden: sensorBoxHidden, isDataBoxHidden: false)
                
                //Adjusting window height
                var heightChange:CGFloat = 0
                if(!sensorBoxHidden){
                    heightChange = self.dataBox.frame.size.height + self.sensorTypeBox.frame.size.height
                }
                else{
                    heightChange = 15
                    if(!dataIntBoxHidden){
                        heightChange += self.dataIntervalBox.frame.size.height
                    }
                    if(!changeTriggerHidden){
                        heightChange += self.changeTriggerBox.frame.size.height
                    }
                    if(!bridgeHidden){
                        heightChange += self.bridgeGainBox.frame.size.height
                    }
                }
                var frame = self.window.frame
                frame.size.height = self.window.minSize.height + heightChange
                self.window.setFrame(frame, display: true, animate: false)
                self.window.center()
            }
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    
    func detach_handler(sender: Phidget){
        DispatchQueue.main.async {
            self.phidgetInfoBox.fillPhidgetInfo(device: nil)
            self.updateGUI(isDataIntHidden: true, isTriggerHidden: true, isBridgeHidden: true, isSensorBoxHidden: true, isDataBoxHidden: true)
            //Adjusting window height
            var frame = self.window.frame
            frame.size.height = self.window.minSize.height
            self.window.setFrame(frame, display: true, animate: false)
            self.window.center()
        }
    }
    
    func error_handler(sender: Phidget, data: (code: ErrorEventCode, description: String)){
        outputError(errorDescription: data.description, errorCode: data.code.rawValue)
    }
    
    func ratiochange_handler(sender: VoltageRatioInput, voltageRatio: Double){
        do{
            let subclass = try sender.getChannelSubclass()
            DispatchQueue.main.async {
                if(subclass == ChannelSubclass.voltageRatioInputBridge){
                    self.voltageRatioLabel.stringValue = String(format:"%.3e V/V", voltageRatio)
                }
                else{
                    self.voltageRatioLabel.stringValue = String(format:"%.3f V/V", voltageRatio)
                }
            }
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }

    }
    
    func sensorchange_handler(sender: VoltageRatioInput, data: (sensorValue: Double, sensorUnit: UnitInfo)){
        DispatchQueue.main.async {
            self.sensorValueLabel.stringValue = String(format:"%.2f %@", data.sensorValue, data.sensorUnit.symbol)
        }
    }
    
    //MARK:GUI Controls
    @IBAction func setChangeTrigger(_ sender: Any) {
        let slider = sender as! NSSlider
        do{
            try ch.setVoltageRatioChangeTrigger(slider.doubleValue)
            changeTriggerLabel.stringValue = String(format:"%.4f V/V", slider.doubleValue)
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    
    @IBAction func setDataInterval(_ sender: Any) {
        let slider = sender as! NSSlider
        do{
            try ch.setDataInterval(UInt32(slider.intValue))
            dataIntervalLabel.stringValue = String(format:"%d ms", UInt32(slider.intValue))
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    @IBAction func setBridgeGain(_ sender: Any) {
        do{
            let popup = sender as! NSPopUpButton
            switch(popup.titleOfSelectedItem!){
            case "1x":
                try ch.setBridgeGain(BridgeGain.gain_1x)
                break
            case "2x":
                try ch.setBridgeGain(BridgeGain.gain_2x)
                break
            case "4x":
                try ch.setBridgeGain(BridgeGain.gain_4x)
                break
            case "8x":
                try ch.setBridgeGain(BridgeGain.gain_8x)
                break
            case "16x":
                try ch.setBridgeGain(BridgeGain.gain_16x)
                break
            case "32x":
                try ch.setBridgeGain(BridgeGain.gain_32x)
                break
            case "64x":
                try ch.setBridgeGain(BridgeGain.gain_64x)
                break
            case "128x":
                try ch.setBridgeGain(BridgeGain.gain_128x)
                break
            default:
                break
            }
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    
    @IBAction func setEnabled(_ sender: Any) {
        do{
            let button = sender as! NSButton
            if(button.state == NSControl.StateValue.on){
                try ch.setBridgeEnabled(true)
            }
            else{
                try ch.setBridgeEnabled(false)
            }
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    
    @IBAction func setSensorType(_ sender: Any) {
        do{
            let popup = sender as! NSPopUpButton
            for (name, type) in sensors{
                if(popup.titleOfSelectedItem == name){
                    try ch.setSensorType(type)
                }
            }
            let sensorType = try ch.getSensorType()
            if(sensorType == VoltageRatioSensorType.voltageRatio){
                sensorModeChanged(isSensorTypeEnabled: false)
            }
            else{
                sensorModeChanged(isSensorTypeEnabled: true)
            }
            
        } catch let err as PhidgetError {
            outputError(errorDescription: err.description, errorCode: err.errorCode.rawValue)
        } catch {
            print (error)
        }
    }
    
    //MARK: Misc
    func updateGUI(isDataIntHidden:Bool, isTriggerHidden:Bool, isBridgeHidden:Bool, isSensorBoxHidden:Bool, isDataBoxHidden:Bool){
        DispatchQueue.main.async {
            self.dataBox.isHidden = isDataBoxHidden;
            self.dataIntervalBox.isHidden = isDataIntHidden
            self.changeTriggerBox.isHidden = isTriggerHidden
            self.sensorTypeBox.isHidden = isSensorBoxHidden
            self.bridgeGainBox.isHidden = isBridgeHidden
            self.enableBox.isHidden = isBridgeHidden
        }
    }
    
    func sensorModeChanged(isSensorTypeEnabled:Bool){
        DispatchQueue.main.async {
            if(isSensorTypeEnabled){
                self.voltageRatioLabel.textColor = NSColor.gray
                self.sensorValueLabel.textColor = NSColor.black
            }
            else{
                self.voltageRatioLabel.textColor = NSColor.black
                self.sensorValueLabel.textColor = NSColor.gray
            }
        }
    }
    
    //MARK: Error
    func outputError(errorDescription:String, errorCode:UInt32){
        DispatchQueue.main.async {
            self.errorCounter += 1
            let outputString = NSAttributedString(string: String(format:"Error %d: %@\n", errorCode, errorDescription))
            self.errorEventLog.textStorage?.beginEditing()
            self.errorEventLog.textStorage?.append(outputString)
            self.errorEventLog.textStorage?.endEditing()
            self.errorEventCount.stringValue = "\(self.errorCounter)"
            if(!self.errorEventWindow.isVisible){
                self.errorEventWindow.setIsVisible(true)
                self.errorEventWindow.center()
            }
        }
    }
    
    @IBAction func clearError(_ sender: Any) {
        errorEventLog.textStorage?.setAttributedString(NSAttributedString(string: ""))
        errorCounter = 0
        errorEventCount.stringValue = "0"
    }
}

